void motor_open() {
  pinMode(PIN_DIR_L, OUTPUT);
  pinMode(PIN_PWM_L, OUTPUT);
  pinMode(PIN_DIR_R, OUTPUT);
  pinMode(PIN_PWM_R, OUTPUT);
  pinMode(PIN_DIR_M, OUTPUT);
  pinMode(PIN_PWM_M, OUTPUT);
  analogWrite(PIN_PWM_L, 0);
  analogWrite(PIN_PWM_R, 0);
  analogWrite(PIN_PWM_M, 0);
}

void motor_set(int pwm_l, int pwm_r) {
  // モータ回転方向の補正
  pwm_l *= -1;
  //pwm_r *= -1;

  if (pwm_l >  255) pwm_l =  255;
  if (pwm_l < -255) pwm_l = -255;
  if (pwm_r >  255) pwm_r =  255;
  if (pwm_r < -255) pwm_r = -255;

  if (pwm_l > 0) {
    digitalWrite(PIN_DIR_L, HIGH);
    analogWrite(PIN_PWM_L, pwm_l);
  } else {
    digitalWrite(PIN_DIR_L, LOW);
    analogWrite(PIN_PWM_L, -pwm_l);
  }
  if (pwm_r > 0) {
    digitalWrite(PIN_DIR_R, HIGH);
    analogWrite(PIN_PWM_R, pwm_r);
  } else {
    digitalWrite(PIN_DIR_R, LOW);
    analogWrite(PIN_PWM_R, -pwm_r);
  }
}

void motor_set_m(int pwm_m){
    if (pwm_m >  255) pwm_m =  255;
    if (pwm_m < -255) pwm_m = -255;
    
    if (pwm_m > 0) {
      digitalWrite(PIN_DIR_M, HIGH);
      analogWrite(PIN_PWM_M, pwm_m);
    } else {
      digitalWrite(PIN_DIR_M, LOW);
      analogWrite(PIN_PWM_M, -pwm_m);
    }
}

void motor_set_line(int pwm_line){
    if (pwm_line >  255) pwm_line =  255;
    if (pwm_line < -255) pwm_line = -255;
    
    if (pwm_line > 0) {
      digitalWrite(PIN_DIR_LINE, HIGH);
      analogWrite(PIN_PWM_LINE, pwm_line);
    } else {
      digitalWrite(PIN_DIR_LINE, LOW);
      analogWrite(PIN_PWM_LINE, -pwm_line);
    }
}
